package cn.ey.biz.module.system.service.app;

import cn.ey.biz.common.pojo.PageResult;
import cn.ey.biz.module.system.api.app.dto.AppDTO;
import cn.ey.biz.module.system.controller.admin.app.vo.*;
import cn.ey.biz.module.system.dal.dataobject.app.AppDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;

/**
 * 系统应用 Service 接口
 */
public interface AppService {

    /**
     * 创建系统应用
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createApp(@Valid AppCreateReqVO createReqVO);

    /**
     * 批量导入系统应用
     *
     * @param createReqVO 创建信息
     */
    void importApp(@Valid List<AppDTO> createReqVO);

    /**
     * 更新系统应用
     *
     * @param updateReqVO 更新信息
     */
    void updateApp(@Valid AppUpdateReqVO updateReqVO);

    /**
     * 删除系统应用
     *
     * @param id 编号
     */
    void deleteApp(Long id);

    /**
     * 获得系统应用
     *
     * @param id 编号
     * @return 系统应用
     */
    AppRespVO getApp(Long id);

    /**
     * 获得系统应用列表
     *
     * @param ids 编号
     * @return 系统应用列表
     */
    List<AppDO> getAppList(Collection<Long> ids);

    /**
     * 获得系统应用分页
     *
     * @param pageReqVO 分页查询
     * @return 系统应用分页
     */
    PageResult<AppRespVO> getAppPage(AppPageReqVO pageReqVO, String acceptLanguage);

    /**
     * 获得系统应用列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 系统应用列表
     */
    List<AppDO> getAppList(AppExportReqVO exportReqVO);


    /**
     * 获取微服务应用
     *
     * @return
     */
    List<AppDO> getAppList();

    List<AppDO> getAllApp();
}
